<?php


class ZipHandler {
    //static $exe = '"C:\Program Files\7-Zip\7za"';
    static $exe = "ulimit -v 8192 && 7za";
    
    var $name;
    var $content=array();
    var $folders=array();
    var $type='7zip';
    
    var $error=null;
    
    
    function open( $name, $type='7z', $list=true ) {
        if(PHP_OS == "WINNT")
            self::$exe = '"C:\Program Files\7-Zip\7za"';
        if ( file_exists($name) ){
            if ( $list ) {
                $ret = $this->getFileList( $name, $type, $this->content, $this->folders );
                if ( $ret!==true ) {
                    $this->error = $ret;
                    return false;
                }
            }                
            $this->name = "'" . str_replace("'", "'\\''", $name) . "'" ;
            $this->type = $type;
            
            return true;
        }
        $this->error = Yii::t('app', 'File not found');
        return false;
    }
    
    function close( ) {
    }
    
    function fileList( ) {
        return sefl::getFileList( $this->name );
    }
    
    static function getFileList( $name, $type, &$content, &$folders ) {
        $out = array();
        $code = 0;
        if(PHP_OS == "WINNT")
            self::$exe = '"C:\Program Files\7-Zip\7za"';
        
        $cmd = self::$exe." l ".$name." 2>&1";
        
        $last = exec( $cmd, $output, $code );
        if ( $code!=0) {
            return Yii::t('app', 'Archive cannot be parsed');
        }
        if ( $type=='zip' ) {
            // check that there are not a single UTF-8 char in the zip file
            foreach ($output as $line ) {
                $enc = mb_detect_encoding($line);
                if ( $enc!="ASCII" ) {
                    return Yii::t('app', 'Zip file contains invalid encoding:')." ".$enc.". ".Yii::t('app', 'Only ASCII characters are supported. Use 7-Zip format for non-ASCII characters.');
                }
            }
        }
		
        foreach ($output as $line ) {
            $ok = preg_match("/\S+\s+\S+\s+(\S+)\s+\S+\s+\S+\s+(.*)/u", $line, $matches);
			if ( !$ok )
				$ok = preg_match("/\S+\s+\S+\s+(\S+)\s+\S+\s+(.*)/u", $line, $matches);
            if ( $ok ){
			    if ($matches[1]=="....." || $matches[1]=="....A"){
                    // file
                    if ( !preg_match("/\.preview/u", $matches[2] ) )
                        $content[]=$matches[2];
                }elseif ($matches[1]=="D...."){
                    // folder
                    $folders[]=$matches[2];
                }
            }
        }
        return true;
    }
    
    function extractFolderTo( $dest, $basepath ) {
        if(PHP_OS == "WINNT")
            self::$exe = '"C:\Program Files\7-Zip\7za"';
            
        if(PHP_OS == "WINNT")
            $cmd = self::$exe." x ".$this->name." -aoa -o".$dest." ".$basepath."*"." 2>&1";
        else {
            $cmd = self::$exe." x ".$this->name." -aoa -o".escapeshellarg($dest)." ".escapeshellarg($basepath."*")." 2>&1";
            
            if ( $basepath=="*/" )
                $cmd .= " && chmod -R -- a+rX ".escapeshellarg($dest);
            else
                $cmd .= " && chmod -R -- a+rX ".escapeshellarg($dest.$basepath);
        }
        
        
        $last = exec( $cmd, $output, $code );
        if ( $code!=0) {
            $this->error = Yii::t('app', 'File extraction failed')." ($code)";
            return false; // cannot list the content
        }
        
        $out = array();
        foreach ($output as $line ) {
            if (preg_match("/Extracting\s+(.*)/u", $line, $matches) ){
                $out[] = $matches[1];
            }
        }
        
        return $out;
    }
    function extractFfileTo( $dest, $files ) {
        if(PHP_OS == "WINNT")
            self::$exe = '"C:\Program Files\7-Zip\7za"';
        $cmd = self::$exe." x ".$this->name." -aoa -o".$dest;
        
        foreach ($files as $file ) {
            if(PHP_OS == "WINNT")
                $cmd .= " ".$file;
            else
                $cmd .= " ".escapeshellarg($file);
        }
        $cmd .= " 2>&1";
        
        $last = exec( $cmd, $output, $code );
        if ( $code!=0) {
            $this->error = Yii::t('app', 'File extraction failed');
            return false; // cannot list the content
        }
        
        $out = array();
        foreach ($output as $line ) {
            if (preg_match("/Extracting\s+(.*)/u", $line, $matches) ){
                $out[] = $matches[1];
            }
        }
        
        return $out;
    }
    function extractExtTo( $dest, $ext ) {
        if(PHP_OS == "WINNT")
            self::$exe = '"C:\Program Files\7-Zip\7za"';
        if ( is_array($ext) ) {
            $cmd = self::$exe." e ".$this->name." -aoa -o".$dest." -r ";
            $found=false;
            foreach ($ext as $e){
                if ($e=='zip' || $e=='7z' || $e=='xml' )
                    continue;
                if ( $e=='png' )
                    $cmd.="*.png *.PNG -x!.preview.* -x!*.preview.* ";
                else
                    $cmd.="*.".$e." *.".strtoupper($e)." *.preview.*.$e.png ";
                $found=true;
            }
            $cmd.="2>&1";
            if ( !$found )
                return array();
        } else {
            if ($ext=='zip' || $ext=='7z' || $ext=='xml' )
                return array(); // we don't do zip files
            if ( $ext=='png' )
                $cmd = self::$exe." e ".$name." -o".$dest." -r *.png -x!.preview.* 2>&1";
            else
                $cmd = self::$exe." e ".$name." -o".$dest." -r *.".$ext." *.preview.*.$ext.png 2>&1";
        }        
        
        $last = exec( $cmd, $output, $code );
        if ( $code!=0) {
            $this->error = Yii::t('app', 'File extraction failed');
            
            return false; // cannot list the content
        }
        $out = array();
        foreach ($output as $line ) {
            if (preg_match("/Extracting\s+(.*)/u", $line, $matches) ){
                if ( !preg_match("/\.preview/u", $matches[1] ) )
                    $out[] = FileItem::basenamepath( $matches[1], $path );
            }
        }
        
        return $out;
    }
    
    function createArchive( $file, $paths, $base) {
        if(PHP_OS == "WINNT")
            self::$exe = '"C:\Program Files\7-Zip\7za"';
           
        $file = "'" . str_replace("'", "'\\''", $file) . "'" ;
        
        $cmd = "cd $base 2>&1 && ".self::$exe." a ".$file." -t7z -mx0";
        foreach ($paths as $path ) {
            $cmd.=" ".$path;
        }
        $cmd.=" 2>&1";
        
        $last = exec( $cmd, $output, $code );
        if ( $code!=0) {
            $this->error = Yii::t('app', 'Archive creation failed');
            return false; // cannot list the content
        }
        return true;
    }
 }